//+------------------------------------------------------------------+
//|                                                     zzzzzzzz.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Red


extern int ForBars=36;

double  Upper_UnikalValues[];
int     Upper_UnikalCounter[];

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   //ForBars=ForHours*(60.0/Period());
   
   ArrayResize(Upper_UnikalValues,0);
   ArrayResize(Upper_UnikalCounter,0);   
   
     
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

   bool unres,lnres;


   
   int tmpc;
   
   static int LastTime;
   static double Upper_LastNewValue;

   Alert("===================================");
   int limit=Bars-IndicatorCounted();
   
   
      for(int i=limit;i>=0;i--){
      //continue;
            if(LastTime==Time[i]){
               continue;
            }
         
         unres=false;
            
         LastTime=Time[i];       
         


         double Upper_LastValue=ND(iFractals(NULL,0,MODE_UPPER,i+ForBars+3));
            if(Upper_LastValue!=0){
            
            if(StrToTime("2007.11.01 08:25")==Time[i+ForBars+3]){
               Alert(" :  ",Upper_LastValue);
               Alert("  - ^");  
                  for(int j=0;j<ArraySize(Upper_UnikalValues);j++){
                     Alert(j," - ",Upper_UnikalValues[j]);//,"("+Upper_UnikalCounter[j]+")");
                  }  
               tmpc=ArrayBsearch(Upper_UnikalValues,Upper_LastValue,ArraySize(Upper_LastValue),0,MODE_DESCEND);             
               Alert(" : "+tmpc,"     : ",Upper_UnikalValues[tmpc]);
            }
            
            if(ArraySize(Upper_UnikalValues)>0){
               tmpc=ArrayBsearch(Upper_UnikalValues,Upper_LastValue,ArraySize(Upper_LastValue),0,MODE_DESCEND);

                  if(ND(Upper_UnikalValues[tmpc])==Upper_LastValue){
                     Upper_UnikalCounter[tmpc]--;
                        if(Upper_UnikalCounter[tmpc]<=0){
                              for(int k=tmpc;k<ArraySize(Upper_UnikalValues)-1;k++){
                                 Upper_UnikalValues[k]=Upper_UnikalValues[k+1];
                                 Upper_UnikalCounter[k]=Upper_UnikalCounter[k+1];                              
                              }
                           ArrayResize(Upper_UnikalValues,ArraySize(Upper_UnikalValues)-1);
                           ArrayResize(Upper_UnikalCounter,ArraySize(Upper_UnikalCounter)-1); 
                        }
                        else{
                           //Alert("asd: "+Upper_UnikalCounter[tmpc]);
                        }
                     /* */
                  } 
                   
               unres=true;              
            }
            }           

         double Upper_NowValue=ND(iFractals(NULL,0,MODE_UPPER,i+3));
            if(Upper_NowValue!=0){
               Upper_LastNewValue=Upper_NowValue;
                  if(ArraySize(Upper_UnikalValues)>0){
                     tmpc=ArrayBsearch(Upper_UnikalValues,Upper_NowValue,WHOLE_ARRAY,0,MODE_ASCEND);
                        if(Upper_UnikalValues[tmpc]==Upper_NowValue){
                           Upper_UnikalCounter[tmpc]++;
                        }
                        else{
                           tmpc=ArraySize(Upper_UnikalValues);
                           ArrayResize(Upper_UnikalValues,tmpc+1);
                           Upper_UnikalValues[tmpc]=Upper_NowValue;
                           ArrayResize(Upper_UnikalCounter,tmpc+1);
                           Upper_UnikalCounter[tmpc]=1;
                        }               
                  }
                  else{
                     tmpc=ArraySize(Upper_UnikalValues);
                     ArrayResize(Upper_UnikalValues,tmpc+1);
                     Upper_UnikalValues[tmpc]=Upper_NowValue;
                     ArrayResize(Upper_UnikalCounter,tmpc+1);
                     Upper_UnikalCounter[tmpc]=1;               
                  }
               unres=true;
            }

      }
      
      
      //Alert(ArraySize(Upper_UnikalValues));


   return(0);
}
//+------------------------------------------------------------------+

double ND(double v){return(NormalizeDouble(v,Digits));}

